Index: /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/analyze_output.py
===================================================================
--- /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/analyze_output.py	(revision 13685)
+++ /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/analyze_output.py	(revision 13686)
@@ -135,5 +135,5 @@
     cv_rf_t = cv+'_tol'
     cv_nemo = l_var_ot[jv]
-    print('\n\n ==== Checking flux '+cv_rf_m+' ('+cv_nemo+') !')
+    print('\n\n ==== Checking variable '+cv_nemo+' against '+cv_rf_m+' !')
 
     F_rf_m = nmp.zeros( Nt )
Index: /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/sbcblk_sanity_check.sh
===================================================================
--- /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/sbcblk_sanity_check.sh	(revision 13685)
+++ /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/sbcblk_sanity_check.sh	(revision 13686)
@@ -70,5 +70,5 @@
 i_si3=0
 FCPP="${SASF_WRK_DIR}/cpp_${CONFIG_BLD}.fcm"
-if [ ! -f ${FCPP} ]; then echo " Mhhh, we did not find 'cpp_STATION_ASF.fcm' into `dirname ${FCPP}` !"; exit; fi
+if [ ! -f ${FCPP} ]; then echo " Mhhh, we could not find 'cpp_STATION_ASF.fcm' into `dirname ${FCPP}` !"; exit; fi
 ca=`cat ${FCPP} | grep 'key_si3'`
 
@@ -95,5 +95,8 @@
 
 
-if [ ! -d ${DATA_IN_DIR} ]; then echo "PROBLEM!!! => did not find directory 'input_data' with input forcing..."; exit; fi
+CFGS_SHARED="${NEMO_REF_DIR}/cfgs/SHARED"
+if [ ! -d ${CFGS_SHARED} ]; then echo "PROBLEM!!! => could not find directory ${CFGS_SHARED} !"; exit; fi
+
+if [ ! -d ${DATA_IN_DIR} ]; then echo "PROBLEM!!! => could not find directory 'input_data' with input forcing..."; exit; fi
 
 cdt_cmpl="`\ls -l ${NEMO_EXE} | cut -d' ' -f 6,7,8`"
@@ -124,8 +127,10 @@
 ################
 
-list_xml="iodef.xml file_def_nemo-oce.xml field_def_nemo-oce.xml"
+list_xml_ref="field_def_nemo-oce.xml domain_def_nemo.xml grid_def_nemo.xml"
+list_xml_cfg="iodef.xml file_def_nemo-oce.xml"
 fcntxt="context_nemo_OCE.xml"
 if [ ${i_sea_ice} -eq 1 ]; then
-    list_xml+=" file_def_nemo-ice.xml field_def_nemo-ice.xml"
+    list_xml_ref+=" field_def_nemo-ice.xml"
+    list_xml_cfg+=" file_def_nemo-ice.xml"
     fcntxt="context_nemo_OCE+ICE.xml"
 fi
@@ -136,15 +141,11 @@
 
 # All remaining "*.xml" files:
-for ff in ${list_xml} ; do
+for ff in ${list_xml_cfg} ; do
     if [ ! -f ${SASF_EXPREF}/${ff} ]; then echo " Mhhh, ${ff} not found into ${SASF_EXPREF} !"; exit; fi
     rsync -avPL ${SASF_EXPREF}/${ff} ${PROD_DIR}/
 done
-
-
-# Getting reference/defaults files from reference NEMO distro:
-rdir="${NEMO_REF_DIR}/cfgs/SHARED"
-for ff in "domain_def_nemo.xml" "grid_def_nemo.xml"; do
-    if [ ! -f ${rdir}/${ff} ]; then echo " Mhhh, ${ff} not found into ${rdir} !"; exit; fi
-    ln -sf ${rdir}/${ff} ${PROD_DIR}/.
+for ff in ${list_xml_ref} ; do
+    if [ ! -f ${CFGS_SHARED}/${ff} ]; then echo " Mhhh, ${ff} not found into ${CFGS_SHARED} !"; exit; fi
+    rsync -avPL ${CFGS_SHARED}/${ff} ${PROD_DIR}/
 done
 
@@ -175,5 +176,5 @@
         # The namelists:
         rsync -avPL ${SASF_EXPREF}/${DIR_NL}/namelist_${scase}_cfg ${PROD_DIR}/namelist_cfg
-        rsync -avPL ${SASF_EXPREF}/namelist_ref                   ${PROD_DIR}/namelist_ref
+        rsync -avPL ${CFGS_SHARED}/namelist_ref                    ${PROD_DIR}/namelist_ref
     
         cd ${PROD_DIR}/
Index: /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/MY_SRC/icestp.F90
===================================================================
--- /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/MY_SRC/icestp.F90	(revision 13685)
+++ /NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/MY_SRC/icestp.F90	(revision 13686)
@@ -74,5 +74,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/ICE 4.0 , NEMO Consortium (2018)
-   !! $Id: icestp.F90 13641 2020-10-19 18:16:58Z clem $
+   !! $Id: icestp.F90 13655 2020-10-21 14:15:13Z laurent $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -127,4 +127,6 @@
          !    utau_ice, vtau_ice = surface ice stress [N/m2]
          !------------------------------------------------!
+                                        CALL ice_sbc_tau( kt, ksbc, utau_ice, vtau_ice )
+         !
          !------------------------------------------------------!
          ! --- Thermodynamical coupling with the atmosphere --- !
@@ -150,10 +152,4 @@
          !!=============================================================
 
-         !IF(lwp) WRITE(numout,*) ''
-         !IF(lwp) WRITE(numout,*) 'LOLO:ice_stp()@icestp.F90 => calling "ice_update_flx()" at kt =', kt
-         !                               CALL ice_update_flx( kt )     ! -- Update ocean surface mass, heat and salt fluxes
-         !IF(lwp) WRITE(numout,*) 'LOLO:ice_stp()@icestp.F90 => Done with "ice_update_flx()" at kt =', kt
-         !IF(lwp) WRITE(numout,*) ''
-
          ! --- case we bypass ice thermodynamics --- !
          !IF( .NOT. ln_icethd ) THEN   ! we suppose ice is impermeable => ocean is isolated from atmosphere
@@ -196,6 +192,4 @@
       ! --- Ocean time step --- !
       !-------------------------!
-      !IF( ln_icedyn )                   CALL ice_update_tau( kt, uu(:,:,1,Kbb), vv(:,:,1,Kbb) )   ! -- update surface ocean stresses
-      !!gm   remark, the ocean-ice stress is not saved in ice diag call above .....  find a solution!!!
       !
       IF( ln_timing )   CALL timing_stop('ice_stp')
@@ -238,4 +232,6 @@
       !
       CALL ice_sbc_init                ! set ice-ocean and ice-atm. coupling parameters
+      !
+      fr_i  (:,:)   = at_i(:,:)        ! initialisation of sea-ice fraction
       !
       IF( ln_rstart )   CALL iom_close( numrir )  ! close input ice restart file