Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 13695)
@@ -546,4 +546,6 @@
        <field id= "MIGRAZD3"   long_name="Microzooplankton grazing on detritus"      unit="mmol-C/m3/d"    grid_ref="grid_T_3D"  />
        <field id= "MEGRAZP3"   long_name="Mesozooplankton grazing on phytoplankton"  unit="mmol-C/m3/d"    grid_ref="grid_T_3D"  />
+       <field id= "MEGRAZPN3"  long_name="Mesozooplankton grazing on non-diatoms"    unit="mmol-C/m3/d"    grid_ref="grid_T_3D"  />
+       <field id= "MEGRAZPD3"  long_name="Mesozooplankton grazing on diatoms"        unit="mmol-C/m3/d"    grid_ref="grid_T_3D"  />
        <field id= "MEGRAZD3"   long_name="Mesozooplankton grazing on detritus"       unit="mmol-C/m3/d"    grid_ref="grid_T_3D"  />
        <field id= "MEGRAZZ3"   long_name="Mesozooplankton grazing on microzoop"      unit="mmol-C/m3/d"    grid_ref="grid_T_3D"  />
@@ -2452,4 +2454,6 @@
       <field field_ref= "MIGRAZD3"   name="MIGRAZD3"   />
       <field field_ref= "MEGRAZP3"   name="MEGRAZP3"   />
+      <field field_ref= "MEGRAZPN3"  name="MEGRAZPN3"  />
+      <field field_ref= "MEGRAZPD3"  name="MEGRAZPD3"  />
       <field field_ref= "MEGRAZD3"   name="MEGRAZD3"   />
       <field field_ref= "MEGRAZZ3"   name="MEGRAZZ3"   />
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90	(revision 13695)
@@ -657,4 +657,10 @@
                                        (fgmepd(ji,jj) * xthetapd)
                ENDIF
+	       IF ( med_diag%MEGRAZPN3%dgsave ) THEN
+                  megrazpn3(ji,jj,jk) = fgmepn(ji,jj) * xthetapn
+               ENDIF
+	       IF ( med_diag%MEGRAZPD3%dgsave ) THEN
+                  megrazpd3(ji,jj,jk) = fgmepd(ji,jj) * xthetapd
+               ENDIF
 	       IF ( med_diag%MEGRAZD3%dgsave ) THEN
                   megrazd3(ji,jj,jk) = fgmedc(ji,jj)
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 13695)
@@ -888,4 +888,12 @@
              DEALLOCATE( megrazp3 )
           ENDIF          	        
+          IF( med_diag%MEGRAZPN3%dgsave ) THEN
+             CALL iom_put( "MEGRAZPN3"  , megrazpn3 )
+             DEALLOCATE( megrazpn3 )
+          ENDIF
+          IF( med_diag%MEGRAZPD3%dgsave ) THEN
+             CALL iom_put( "MEGRAZPD3"  , megrazpd3 )
+             DEALLOCATE( megrazpd3 )
+          ENDIF	        
           IF( med_diag%MEGRAZD3%dgsave ) THEN
              CALL iom_put( "MEGRAZD3"  , megrazd3 )
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90	(revision 13695)
@@ -815,4 +815,12 @@
             megrazp3(:,:,: )  = 0.0 !! 
          ENDIF
+         IF( med_diag%MEGRAZPN3%dgsave   ) THEN
+            ALLOCATE( megrazpn3(1:jpi, 1:jpj, 1:jpk) )
+            megrazpn3(:,:,: )  = 0.0 !! 
+         ENDIF
+         IF( med_diag%MEGRAZPD3%dgsave   ) THEN
+            ALLOCATE( megrazpd3(1:jpi, 1:jpj, 1:jpk) )
+            megrazpd3(:,:,: )  = 0.0 !! 
+         ENDIF
          IF( med_diag%MEGRAZD3%dgsave   ) THEN
             ALLOCATE( megrazd3(1:jpi, 1:jpj, 1:jpk) )
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_mod.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_mod.F90	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_mod.F90	(revision 13695)
@@ -261,4 +261,5 @@
    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: fediss3,fescav3
    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: migrazp3,migrazd3,megrazp3
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: megrazpn3,megrazpd3
    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: megrazd3, megrazz3
    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: o2sat3,pbsi3,pcal3,remoc3
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 13695)
@@ -2345,4 +2345,14 @@
           med_diag%MEGRAZP3%dgsave = .FALSE.
       ENDIF
+      IF  (iom_use("MEGRAZPN3")) THEN 
+          med_diag%MEGRAZPN3%dgsave = .TRUE.
+      ELSE 
+          med_diag%MEGRAZPN3%dgsave = .FALSE.
+      ENDIF
+      IF  (iom_use("MEGRAZPD3")) THEN 
+          med_diag%MEGRAZPD3%dgsave = .TRUE.
+      ELSE 
+          med_diag%MEGRAZPD3%dgsave = .FALSE.
+      ENDIF
       IF  (iom_use("MEGRAZD3")) THEN 
           med_diag%MEGRAZD3%dgsave = .TRUE.
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 13694)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_biophys/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 13695)
@@ -152,5 +152,5 @@
                   EXPC3, EXPN3, EXPCALC3, EXPSI3,                                                    &
                   FEDISS3, FESCAV3,                                                                  &
-                  MIGRAZP3, MIGRAZD3, MEGRAZP3, MEGRAZD3, MEGRAZZ3,                                  &
+                  MIGRAZP3, MIGRAZD3, MEGRAZP3, MEGRAZPN3, MEGRAZPD3, MEGRAZD3, MEGRAZZ3,            &
                   O2SAT3, PBSI3, PCAL3, REMOC3,                                                      &
                   PNLIMJ3, PNLIMN3, PNLIMFE3, PDLIMJ3, PDLIMN3, PDLIMFE3, PDLIMSI3,                  &