Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 13703)
@@ -299,5 +299,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 13703)
@@ -300,5 +300,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg	(revision 13703)
@@ -330,5 +330,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 13703)
@@ -320,5 +320,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/CANAL/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/CANAL/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/CANAL/EXPREF/namelist_cfg	(revision 13703)
@@ -192,5 +192,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false.  !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/CPL_OASIS/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/CPL_OASIS/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/CPL_OASIS/EXPREF/namelist_cfg	(revision 13703)
@@ -367,5 +367,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg	(revision 13703)
@@ -201,5 +201,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_ens_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_ens_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_ens_cfg	(revision 13703)
@@ -129,5 +129,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg	(revision 13703)
@@ -140,5 +140,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg	(revision 13703)
@@ -140,5 +140,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg	(revision 13703)
@@ -140,5 +140,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg	(revision 13703)
@@ -140,5 +140,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg	(revision 13703)
@@ -140,5 +140,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 13703)
@@ -201,5 +201,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg	(revision 13703)
@@ -140,5 +140,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .true. !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/VORTEX/EXPREF/1_namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/VORTEX/EXPREF/1_namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/VORTEX/EXPREF/1_namelist_cfg	(revision 13703)
@@ -195,5 +195,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/VORTEX/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/VORTEX/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/VORTEX/EXPREF/namelist_cfg	(revision 13703)
@@ -188,5 +188,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/WAD/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/WAD/EXPREF/namelist_cfg	(revision 13702)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/WAD/EXPREF/namelist_cfg	(revision 13703)
@@ -330,5 +330,4 @@
    ln_dynvor_mix = .false. !  mixed scheme
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------