Index: /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/file_def_nemo-oce.xml
===================================================================
--- /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/file_def_nemo-oce.xml	(revision 13705)
+++ /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/file_def_nemo-oce.xml	(revision 13706)
@@ -28,6 +28,4 @@
           <field field_ref="ssh"          name="sossheig"  operation = "instant" />
           <field field_ref="wetdep"       name="hswe_wd"   operation = "instant" />
-          <field field_ref="rpo"          name="rpo"       operation = "instant" />
-          <field field_ref="bmpt"         name="bmpt"      operation = "instant" />
         </file>
 
@@ -38,5 +36,4 @@
           <field field_ref="ssu"          name="ssu"        operation = "instant"  />
           <field field_ref="utau"         name="sozotaux"   operation = "instant"  />
-          <field field_ref="bmpt"         name="bmpv"       operation = "instant" />
         </file>
 
@@ -47,5 +44,4 @@
           <field field_ref="ssv"          name="ssv"        operation = "instant"  />
           <field field_ref="vtau"         name="sometauy"   operation = "instant"  />
-          <field field_ref="bmpv"         name="bmpv"       operation = "instant" />
         </file>
         
Index: /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/namelist_cfg	(revision 13705)
+++ /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/namelist_cfg	(revision 13706)
@@ -22,14 +22,8 @@
    cn_exp      =  "AM98"   !  experience name
    nn_it000    =       1   !  first time step
-   nn_itend    =  1728        !  10 ans -  2 min - last  time step
-!   nn_itend    =  1036800  !  10 ans -  5 min
-!   nn_itend    =   345600  !  10 ans  - 15 min - AM98 1/4deg + P.Marchand
-!   nn_itend    =   172800  !  10 ans  - 30 min - AM98 1/4deg
-!   nn_itend    =    34560  !  10 ans  - 2h
+   nn_itend    =   172800  !  10 ans  - 30 min - AM98 1/4deg
 !   nn_itend    =    86400  !  10 ans  - 1h
    nn_leapy    =      30   !  Leap year calendar (1) or not (0)
-!   nn_stock    = 1036800   !  frequency of creation of a restart file (modulo referenced to 1)
-!   nn_stock    =  34560   !  frequency of creation of a restart file (modulo referenced to 1)
-   nn_write    =      60   !  frequency of write in the output file   (modulo referenced to nn_it000)
+   nn_write    =     480   !  frequency of write in the output file   (modulo referenced to nn_it000)
    nn_istate   =       1   !  output the initial state (1) or not (0)
 /
@@ -44,5 +38,5 @@
    nn_AM98     =     4     !  AM98 resolution [1/nn_AM98]
    jpkglo      =     2     !  number of model levels
-   rn_theta    =    0.    !  rotation angle fo the grid [deg]
+   rn_theta    =     0.    !  rotation angle fo the grid [deg]
    !
    nn_gc       =        2        ! number of ghostcells 
@@ -72,13 +66,7 @@
    ln_linssh   = .false.    !  =T  linear free surface  ==>>  model level are fixed in time
    !
-!   rn_Dt      = 7200.     !  2h    - 1 deg cfg - time step for the dynamics [s]
-!   rn_Dt      = 3600.     !  1h     - AM98 1 deg
-   rn_Dt      = 1800.     !  30min    - AM98 1/4deg
-!   rn_Dt      = 900.      !  15min - AM98 1/4deg + P.Marchand
-!   rn_Dt      = 600.      !  10min - 1/4 deg cfg
-!   rn_Dt      = 300.      !  5min - 1/4 deg cfg 
-!   rn_Dt      = 120.      !  2min - 1/4 deg cfg
-!   rn_Dt      = 60.      !  1min - 1/4 deg cfg 
-   ln_meshmask = .true.   !  =T create a mesh file
+!   rn_Dt      = 3600.     !  1h    - AM98 1 deg
+   rn_Dt       = 1800.     !  30min - AM98 1/4deg
+   ln_meshmask = .false.   !  =T create a mesh file
 /
 !!======================================================================
@@ -169,7 +157,7 @@
    ln_dynvor_eeT = .false. !  energy conserving scheme (een using e3t)
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0  e3f = mi(mj(e3t))/4
+      nn_e3f_typ = 1          ! =0  e3f = mi(mj(e3t))/4
       !                       ! =1  e3f = mi(mj(e3t))/mi(mj( tmask))
-   ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T)        
+   ln_dynvor_msk = .true.  !  vorticity multiplied by fmask (=T)        
       !                    !  (f-point vorticity schemes only)
 /
@@ -188,5 +176,4 @@
       rn_Uv      = 2.0         !  lateral viscous velocity [m/s] 
       rn_Lv      = 500         !  lateral viscous length   [m]  - at 1/4deg 
-!      rn_Lv      = 25.e+3      !  lateral viscous length   [m]  - at 1/4deg 
 !      rn_Lv      = 100.e+3     !  lateral viscous length   [m]  - 1 deg
 /
Index: /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/namelist_ref
===================================================================
--- /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/namelist_ref	(revision 13706)
+++ /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/AM98/EXPREF/namelist_ref	(revision 13706)
@@ -0,0 +1,1 @@
+link ../../../cfgs/SHARED/namelist_ref
Index: /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/demo_cfgs.txt
===================================================================
--- /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/demo_cfgs.txt	(revision 13705)
+++ /NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/demo_cfgs.txt	(revision 13706)
@@ -12,2 +12,3 @@
 STATION_ASF OCE
 CPL_OASIS  OCE TOP ICE NST
+AM98 OCE SWE